

atom/proc/Jump(Power=3,Degen=0.5)	//For upward movements, like jumping, launch pads, etc.
	if(Jumping||Falling) return 	//cant jump more if you're already jumping
	Jumping=1			//now you're jumping
	JumpPower=Power		//Set the temporary variables
	JumpDegen=Degen		//I do them this way instead of being defined in the proc
	spawn() Fall()		//so they can be modified later by other procs
	while(JumpPower>0)	//while you're still going up...
		var/atom/Roof=0	//This is defined this way in case someone overrides
//the default underbump (which sets jumpower to 0). Doing that will make the jumper
//hit the roof and keep their upward momentum, and if they were to move away from the
//roof they would continue going upward.
		for(var/atom/A in loc)	//Loop through bumpable stuff
			if(A==src) continue	//If it is itself, dont worry about it
			if(!A.density) continue	//If they aren't solid then you can't hit them
			if(A.pixel_z<=pixel_z) continue	//If they're below you the likelyhood of you
//hitting them while moving upwards is very slim
			if(A.pixel_z-JumpPower-1 <= pixel_z + Height) //-JumpPower to stop you from going through things
				//When power reaches very high levels
				//Otherwise you could entirely jump through an object
				Roof=A	//Use this later
//				PixZ(A.pixel_z - Height)	//set up your height
				UnderBump(A)	//Bumped them
				A.UnderBumped(src) //and they were underbumped() by us
				break			//break the for() loop, cuz we already hit something
		if(!Roof)	PixZ(pixel_z+round(JumpPower,1))
		else		PixZ(Roof.pixel_z-Height-1) //without -1 you end up too high
		//That would cause you to be the landing point for someone then
		//end up with fallling-through-floor issues
		JumpPower-=JumpDegen	//jump power gets weakened
		sleep(1)
	Jumping=0	//not jumping anymore


atom/proc/Fall()	//Gravity!
	if(Floor.pixel_z+Floor.Height>pixel_z)	//Don't want to fall through our floor
		PixZ(Floor.pixel_z)

	else
		if(GravityMax==0) return//GravityMax==0 means this object never falls
		if(Falling) return		//If we're already falling we dont want to fall more

		Falling=1			//Now we're falling
		Gravity=GravityMin	//Start it out at the defaults
		GravityInterval=GravityIntervalBase	//defaults
		while(Jumping)		//dont fall while jumping.
			sleep(1)		//wait to finish jumping

		while(Floor.pixel_z+Floor.Height<pixel_z) //While the floor is below us
			sleep(GravityInterval)	//wait...

			PixZ(pixel_z-Gravity)	//fall a bit
			if(GravityInterval>1) GravityInterval-- //If possible, fall more often
			else Gravity++ //If not, fall faster

			if(Gravity>GravityMax)Gravity=GravityMax //Can't go over the limit
			for(var/atom/movable/A in Contents)	//Anything above me should also fall
				spawn() A.Fall()	//otherwise they'd be hovering
		if(pixel_z<Floor.pixel_z+Floor.Height) PixZ(Floor.pixel_z+Floor.Height)
		Falling=0
	Landed(Floor)
	Floor.LandedOn(src)


